// THIS CLASS IS NOT CHECKSTYLE COMPLIANT - sorry!

/** Class to create a collection of pictures.
*/
public class PictureCollection {
   private static final int DEFAULT_SIZE = 10;

   private int num;
   private Picture[] pics;

/**	Create a pictureCollection object
*/
   public PictureCollection() {
      pics = new Picture[DEFAULT_SIZE];
      num = 0;
   }

/**	Add a picture object to the collection
	@param p picture to be added to the collection
*/
   public void addPicture(Picture p) {
      if (num == pics.length) 
         resize();
   		
      pics[num] = p;
      num++;
   }

/**	Double the size of the collection
*/
   private void resize() {
      Picture[] temp = new Picture[2*pics.length];
      for (int i = 0; i < pics.length; i++)
         temp[i] = pics[i];
      pics = temp;
   }

/**	Delete a picture object from the collection
	@param sub Subject of picture to be removed
*/
   public void removePicture(String sub) {
      for (int i = 0; i < num; i++)
      {
         if (pics[i].getSubject().equalsIgnoreCase(sub))
         {
            for (int j = i; j < num-1; j++)
               pics[j] = pics[j+1];
            pics[pics.length-1] = null;
            num--;
            return;
         }
      }
      System.out.println("Error: Subject (" + sub + ") cannot be found");
   }

/**	Find picture given its ID
	@param id the ID of the picture to find
	@return the picture if found, null if not
*/
   public Picture findPicture(int id) {
      for (int i = 0; i < num; i++)
      {
         if (pics[i].getID() == id)
            return pics[i];
      }
      return null;
   }

/**	Find largest picture 
	@return the largest picture
*/
   public Picture findLargestPicture() {
      Picture largest = pics[0];
      for (int i = 1; i < num; i++)
      {
         if (pics[i].compareTo(largest) > 0)
            largest = pics[i];
      }
      return largest;
   }

/**	Print the collection of pictures in order from smallest
		to largest perimeter
*/
   public void printPictures() {
      sortPictures();
      for (int i = 0; i < num; i++) 
         System.out.println (pics[i] + "  perim:" + pics[i].perimeter());
   }
	
/**	Sort the collection of pictures in order from smallest
		to largest perimeter
*/
   private void sortPictures() {
      Picture temp; 
      for (int i = pics.length-1; i >= 1; i--) 
         for (int j = 0; j < i; j++) 
            if (pics[j] != null && pics[j+1] != null && 
               	pics[j].compareTo(pics[j+1]) > 0 ) {		
               temp = pics[j]; 
               pics[j] = pics[j+1]; 
               pics[j+1] = temp; 
            }  
   }		
}
